/********************************************************************
 * Copyright © 2016 Computational Molecular Biology Group,          * 
 *                  Freie Universität Berlin (GER)                  *
 *                                                                  *
 * This file is part of ReaDDy.                                     *
 *                                                                  *
 * ReaDDy is free software: you can redistribute it and/or modify   *
 * it under the terms of the GNU Lesser General Public License as   *
 * published by the Free Software Foundation, either version 3 of   *
 * the License, or (at your option) any later version.              *
 *                                                                  *
 * This program is distributed in the hope that it will be useful,  *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of   *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    *
 * GNU Lesser General Public License for more details.              *
 *                                                                  *
 * You should have received a copy of the GNU Lesser General        *
 * Public License along with this program. If not, see              *
 * <http://www.gnu.org/licenses/>.                                  *
 ********************************************************************/


/**
 * << detailed description >>
 *
 * @file PyReaddy.cpp
 * @brief << brief description >>
 * @author clonker
 * @date 16.03.17
 * @copyright GNU Lesser General Public License v3.0
 */

#include <pybind11/pybind11.h>
#include <pybind11/stl.h>
#include <pybind11/numpy.h>

namespace py = pybind11;

void exportCommon(py::module&);
void exportApi(py::module&);
void exportPrototyping(py::module&);

PYBIND11_MODULE (readdybinding, m) {
    py::options options;
    options.enable_function_signatures().enable_user_defined_docstrings();

    m.doc() = "ReaDDy c++-binding python module";

    auto common = m.def_submodule("common", "module containing common utilities and utility classes");
    auto api = m.def_submodule("api", "ReaDDy c++-api python module");
    auto prototyping = m.def_submodule("prototyping", "ReaDDy prototyping python module");
    exportCommon(common);
    exportApi(api);
    exportPrototyping(prototyping);
}